"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PdfLoader = void 0;
var pdfjs_dist_1 = require("pdfjs-dist");
var react_1 = __importStar(require("react"));
// Set the PDF worker
pdfjs_dist_1.GlobalWorkerOptions.workerSrc = "//cdnjs.cloudflare.com/ajax/libs/pdf.js/2.6.347/pdf.worker.min.js";
var PdfLoader = /** @class */ (function (_super) {
    __extends(PdfLoader, _super);
    function PdfLoader(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        return _this;
    }
    PdfLoader.prototype.discardDocument = function (document) {
        document && document.destroy();
    };
    PdfLoader.prototype.componentDidMount = function () {
        this.load();
    };
    PdfLoader.prototype.componentWillUnmount = function () {
        this.discardDocument(this.state.pdfDocument);
    };
    PdfLoader.prototype.componentDidUpdate = function (_a) {
        var url = _a.url;
        if (this.props.url !== url) {
            this.load();
        }
    };
    PdfLoader.prototype.componentDidCatch = function (error, info) {
        var onError = this.props.onError;
        if (onError) {
            onError(error);
        }
        this.setState({ pdfDocument: undefined, error: error });
    };
    PdfLoader.prototype.load = function () {
        var _this = this;
        var url = this.props.url;
        var pdfDocument = this.state.pdfDocument;
        this.setState({ pdfDocument: undefined, error: undefined });
        try {
            this.discardDocument(pdfDocument);
            if (!url)
                return;
            pdfjs_dist_1.getDocument(url).promise.then(function (pdfDocument) {
                _this.setState({ pdfDocument: pdfDocument });
            });
        }
        catch (e) {
            this.componentDidCatch(e);
        }
    };
    PdfLoader.prototype.render = function () {
        var _a = this.props, children = _a.children, beforeLoad = _a.beforeLoad;
        var _b = this.state, pdfDocument = _b.pdfDocument, error = _b.error;
        return error ? this.renderError() : !pdfDocument || !children ? beforeLoad : children(pdfDocument);
    };
    PdfLoader.prototype.renderError = function () {
        var errorMessage = this.props.errorMessage;
        if (errorMessage) {
            return react_1.default.cloneElement(errorMessage, { error: this.state.error });
        }
        return null;
    };
    return PdfLoader;
}(react_1.Component));
exports.PdfLoader = PdfLoader;
