"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PdfViewer = exports.isAreaSelection = void 0;
var react_1 = __importStar(require("react"));
var react_pdf_1 = require("react-pdf");
require("react-pdf/dist/esm/Page/AnnotationLayer.css");
var react_window_1 = require("react-window");
var debounce_1 = require("../../dist/utils/debounce");
require("../style/react_pdf_viewer.css");
var utils_1 = require("../utils");
var coordinates_1 = require("../utils/coordinates");
var PdfPage_1 = require("./PdfPage");
var isAreaSelection = function (selection) { return "image" in selection; };
exports.isAreaSelection = isAreaSelection;
react_pdf_1.pdfjs.GlobalWorkerOptions.workerSrc = "//cdnjs.cloudflare.com/ajax/libs/pdf.js/" + react_pdf_1.pdfjs.version + "/pdf.worker.min.js";
var PdfViewer = /** @class */ (function (_super) {
    __extends(PdfViewer, _super);
    function PdfViewer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            containerHeight: 0,
            textSelectionEnabled: true,
            currentPage: 1,
            numPages: 0,
            responsiveScale: 1,
        };
        /** Total left and right border width, needed as offset to avoid PageCanvas rendering past right page border. */
        _this.BORDER_WIDTH_OFFSET = 18;
        /** Scale value for PDF size */
        _this.scale = 1.2;
        _this.containerDiv = null;
        _this.listDiv = null;
        _this.pageRefs = new Map();
        _this._mounted = false;
        /**
         * Lifecycle function
         */
        _this.componentDidMount = function () {
            var _a;
            _this._mounted = true;
            _this.computeSelectionMap();
            _this.handleResize();
            document.addEventListener("keydown", _this.onKeyDown);
            document.addEventListener("selectstart", _this.onTextSelectionStart);
            document.addEventListener("selectionchange", _this.onTextSelectionChange);
            (_a = document.defaultView) === null || _a === void 0 ? void 0 : _a.addEventListener("resize", _this.debouncedHandleResize);
            // debug
            window.PdfViewer = _this;
        };
        _this.componentDidUpdate = function (prevProps) {
            if (_this.props.selections !== prevProps.selections)
                _this.computeSelectionMap();
            if (_this.props.url !== prevProps.url)
                _this.setState({ documentUuid: undefined });
        };
        _this.componentWillUnmount = function () {
            var _a;
            _this._mounted = false;
            document.removeEventListener("keydown", _this.onKeyDown);
            document.removeEventListener("selectstart", _this.onTextSelectionStart);
            document.removeEventListener("selectionchange", _this.onTextSelectionChange);
            (_a = document.defaultView) === null || _a === void 0 ? void 0 : _a.removeEventListener("resize", _this.debouncedHandleResize);
        };
        /**
         * Helpers
         */
        _this.resetSelections = function () {
            _this.clearTextSelection();
            _this.clearAreaSelection();
        };
        _this.computeSelectionMap = function () {
            if (!_this.props.selections) {
                _this.selectionMap = undefined;
                return;
            }
            var selectionMap = new Map();
            _this.props.selections.forEach(function (selection) {
                var _a;
                selectionMap.set(selection.position.pageNumber, __spreadArrays(((_a = selectionMap.get(selection.position.pageNumber)) !== null && _a !== void 0 ? _a : []), [
                    selection,
                ]));
            });
            _this.selectionMap = selectionMap;
        };
        _this.computePageDimensions = function (pdf) {
            var promises = Array.from({ length: pdf.numPages })
                .map(function (x, i) { return i + 1; })
                .map(function (pageNumber) {
                return new Promise(function (resolve, reject) {
                    pdf.getPage(pageNumber).then(resolve, reject);
                });
            });
            Promise.all(promises).then(function (pages) {
                if (!_this._mounted)
                    return;
                var pageDimensions = new Map();
                for (var _i = 0, pages_1 = pages; _i < pages_1.length; _i++) {
                    var page = pages_1[_i];
                    var width = page.view[2] * _this.scale;
                    var height = page.view[3] * _this.scale;
                    pageDimensions.set(page.pageNumber, { width: width, height: height });
                }
                _this.setState({ pageDimensions: pageDimensions }, function () { return _this.clearPageHeightCache(); });
            });
        };
        _this.getPageHeight = function (index) {
            var _a = _this.state, pageDimensions = _a.pageDimensions, responsiveScale = _a.responsiveScale;
            var pageDimension = pageDimensions === null || pageDimensions === void 0 ? void 0 : pageDimensions.get(index + 1);
            if (pageDimension && responsiveScale)
                return pageDimension.height / responsiveScale + _this.BORDER_WIDTH_OFFSET;
            return 768; // Initial page height
        };
        _this.clearPageHeightCache = function () {
            var _a;
            (_a = _this.listDiv) === null || _a === void 0 ? void 0 : _a.resetAfterIndex(0);
        };
        _this.computeResponsiveScale = function (pageNumber) {
            var _a;
            var node = _this.pageRefs.get(pageNumber);
            var pageDimension = (_a = _this.state.pageDimensions) === null || _a === void 0 ? void 0 : _a.get(pageNumber);
            if (!node || !pageDimension)
                return;
            return pageDimension.height / node.clientHeight;
        };
        _this.handleResize = function () {
            var _a = _this.state, currentPage = _a.currentPage, responsiveScale = _a.responsiveScale;
            // Recompute the responsive scale factor on window resize
            var newResponsiveScale = _this.computeResponsiveScale(currentPage);
            if (newResponsiveScale && newResponsiveScale !== responsiveScale) {
                _this.setState({ responsiveScale: newResponsiveScale }, function () { return _this.clearPageHeightCache(); });
            }
            if (_this.containerDiv)
                _this.setState({ containerHeight: _this.containerDiv.clientHeight });
        };
        _this.debouncedHandleResize = debounce_1.debounce(_this.handleResize, 500);
        _this.getItemKey = function (index) {
            return "doc_" + _this.state.documentUuid + "_page_" + index;
        };
        /**
         * Text selection handlers
         */
        _this.clearTextSelection = function () {
            var _a, _b, _c;
            (_a = utils_1.getWindow(_this.containerDiv).getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges();
            (_c = (_b = _this.props).onTextSelection) === null || _c === void 0 ? void 0 : _c.call(_b);
        };
        _this.onTextSelectionStart = function () {
            _this.clearAreaSelection();
        };
        _this.onTextSelectionChange = function () {
            var _a, _b;
            var selection = utils_1.getWindow(_this.containerDiv).getSelection();
            if (!selection || selection.isCollapsed)
                return;
            var range = selection.rangeCount > 0 ? selection.getRangeAt(0) : undefined;
            if (!range)
                return;
            var page = utils_1.getPageFromRange(range);
            if (!page)
                return;
            var pageDimension = { width: page.node.clientWidth, height: page.node.clientHeight };
            var rects = utils_1.getClientRects(range, page.node);
            if (rects.length === 0)
                return;
            var boundingRect = utils_1.getBoundingRect(rects);
            var position = coordinates_1.normalizePosition({ boundingRect: boundingRect, rects: rects, pageNumber: page.number }, pageDimension);
            var text = Array.from(range.cloneContents().childNodes).reduce(function (a, b) { return a + " " + b.textContent; }, "");
            (_b = (_a = _this.props).onTextSelection) === null || _b === void 0 ? void 0 : _b.call(_a, { position: position, text: text });
        };
        /**
         * Area selection handlers
         */
        _this.clearAreaSelection = function () {
            var _a, _b;
            _this.setState({ areaSelectionActivePage: undefined, textSelectionEnabled: true });
            (_b = (_a = _this.props).onAreaSelection) === null || _b === void 0 ? void 0 : _b.call(_a);
        };
        _this.onAreaSelectionStart = function (pageNumber) {
            _this.clearTextSelection();
            _this.setState({ textSelectionEnabled: false, areaSelectionActivePage: pageNumber });
        };
        _this.onAreaSelectionEnd = function (selection) {
            var _a, _b;
            _this.setState({ textSelectionEnabled: true });
            (_b = (_a = _this.props).onAreaSelection) === null || _b === void 0 ? void 0 : _b.call(_a, selection);
        };
        /**
         * Event handlers
         */
        _this.onKeyDown = function (event) {
            if (event.key === "Escape")
                _this.resetSelections();
        };
        _this.onMouseDown = function () {
            _this.resetSelections();
        };
        _this.onDocumentLoad = function (pdf) {
            _this.computePageDimensions(pdf);
            _this.setState({ numPages: pdf.numPages, documentUuid: utils_1.generateUuid() });
        };
        _this.updateCurrentVisiblePage = function (_a) {
            var visibleStopIndex = _a.visibleStopIndex;
            _this.setState({ currentPage: visibleStopIndex + 1 });
        };
        _this.render = function () {
            var _a = _this.state, containerHeight = _a.containerHeight, numPages = _a.numPages;
            return (react_1.default.createElement("div", { ref: function (ref) { return (_this.containerDiv = ref); }, style: {
                    position: "relative",
                    width: "100%",
                    height: "100%",
                }, onContextMenu: function (e) { return e.preventDefault(); }, onPointerDown: _this.onMouseDown },
                react_1.default.createElement(react_pdf_1.Document, { file: _this.props.url, onLoadSuccess: _this.onDocumentLoad, options: { removePageBorders: false } }, _this.containerDiv && _this.state.documentUuid && _this.state.pageDimensions && (react_1.default.createElement(react_window_1.VariableSizeList, { ref: function (ref) { return (_this.listDiv = ref); }, height: containerHeight, width: "100%", itemCount: numPages, itemKey: _this.getItemKey, itemSize: _this.getPageHeight, itemData: {
                        pageRefs: _this.pageRefs,
                        areaSelectionActivePage: _this.state.areaSelectionActivePage,
                        pageDimensions: _this.state.pageDimensions,
                        selectionMap: _this.selectionMap,
                        enableAreaSelection: _this.props.enableAreaSelection,
                        onAreaSelectionStart: _this.onAreaSelectionStart,
                        onAreaSelectionEnd: _this.onAreaSelectionEnd,
                    }, overscanCount: 2, onItemsRendered: _this.updateCurrentVisiblePage }, PdfPage_1.PdfPage))),
                _this.props.children));
        };
        return _this;
    }
    return PdfViewer;
}(react_1.Component));
exports.PdfViewer = PdfViewer;
