"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.absoluteBoundingRectToStyle = exports.boundingRectToStyle = exports.normalizePosition = exports.normalizeBoundingRect = void 0;
var normalizeBoundingRect = function (rect, _a) {
    var width = _a.width, height = _a.height;
    return {
        left: (rect.left * 100) / width,
        top: (rect.top * 100) / height,
        right: (rect.right * 100) / width,
        bottom: (rect.bottom * 100) / height,
    };
};
exports.normalizeBoundingRect = normalizeBoundingRect;
var normalizePosition = function (position, dimensions) {
    return {
        absolute: {
            boundingRect: position.boundingRect,
            rects: position.rects,
        },
        normalized: {
            boundingRect: exports.normalizeBoundingRect(position.boundingRect, dimensions),
            rects: position.rects.map(function (rect) { return exports.normalizeBoundingRect(rect, dimensions); }),
        },
        pageNumber: position.pageNumber,
    };
};
exports.normalizePosition = normalizePosition;
var boundingRectToStyle = function (rect, _a) {
    var width = _a.width, height = _a.height;
    return ({
        left: rect.left + "%",
        top: rect.top + "%",
        width: ((rect.right - rect.left) * width) / 100,
        height: ((rect.bottom - rect.top) * height) / 100,
    });
};
exports.boundingRectToStyle = boundingRectToStyle;
var absoluteBoundingRectToStyle = function (rect) { return ({
    left: rect.left,
    top: rect.top,
    width: rect.right - rect.left,
    height: rect.bottom - rect.top,
}); };
exports.absoluteBoundingRectToStyle = absoluteBoundingRectToStyle;
